"use strict";
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var fresh_id_1 = require("fresh-id");
var axios_1 = require("axios");
var react_native_async_storage_utils_1 = require("react-native-async-storage-utils");
var lodash_1 = require("lodash");
var semaphore_async_await_1 = require("semaphore-async-await");
var NIBBANA_VERSION = require('../package.json').version;
var APP_VERSION = null;
try {
    var appPackageJson = require('../../../package.json');
    APP_VERSION = lodash_1.get(appPackageJson, 'version', null);
}
catch (e) { }
var ASYNC_STORAGE_USER_IDENTIFICATION_KEY = 'nibbana.userIdentification';
var ASYNC_STORAGE_USERS_FIRST_IDENTIFIED_AT = 'nibbana.usersFirstIdentifiedAt';
var ASYNC_STORAGE_PERSISTENT_SUPER_PROPERTIES_KEY = 'nibbana.persistentSuperProperties';
var ASYNC_STORAGE_ENTRIES_KEY = 'nibbana.entries';
var UPLOAD_TIMEOUT = 15 * 1000;
var UPLOAD_INTERVAL = 60 * 1000;
var Nibbana = /** @class */ (function () {
    function Nibbana() {
        this.config = null;
        this.userIdentification = null;
        this.uploadLock = new semaphore_async_await_1.Lock();
        this.entriesLock = new semaphore_async_await_1.Lock();
        this.transientSuperProperties = {};
        this.persistentSuperProperties = {};
        this.startTimerCalledAtDates = {};
        if (Nibbana._shared) {
            throw new Error('The Nibbana class is a singleton');
        }
        Nibbana._shared = this;
    }
    /**
     * Returns the Nibbana instance. You shouldn't have to call this function, in fact you shouldn't even have access to it
     *
     * @static
     * @returns The shared nibbana instance
     * @memberof Nibbana
     */
    Nibbana.shared = function () {
        if (Nibbana._shared) {
            return Nibbana._shared;
        }
        else {
            return new Nibbana();
        }
    };
    Nibbana.prototype.ensureConfig = function () {
        if (!this.config) {
            throw new Error('You have to call nibbana.initialize before any other method');
        }
        return this.config;
    };
    Nibbana.prototype.initialize = function () {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            var endpoint_1, nibbanaToken_1, _a, AsyncStorage, AppState, _b, _c;
            return __generator(this, function (_d) {
                switch (_d.label) {
                    case 0:
                        if (this.config) {
                            throw new Error('nibbana has already been initialized');
                        }
                        if (args.length === 1) {
                            this.config = args[0];
                        }
                        else {
                            endpoint_1 = args[0], nibbanaToken_1 = args[1];
                            _a = require('react-native'), AsyncStorage = _a.AsyncStorage, AppState = _a.AppState;
                            this.config = {
                                asyncStorage: AsyncStorage,
                                uploadEntries: function (entries) {
                                    return axios_1.default({
                                        method: 'POST',
                                        url: endpoint_1 + "/upload-entries",
                                        data: { entries: entries },
                                        headers: {
                                            'nibbana-token': nibbanaToken_1,
                                        },
                                        timeout: UPLOAD_TIMEOUT,
                                    }).catch(function () { return null; });
                                },
                            };
                            // AppState.addEventListener('change', (nextAppState: string) => {
                            //   console.log(nextAppState)
                            // })
                        }
                        _b = this;
                        return [4 /*yield*/, react_native_async_storage_utils_1.getObject(this.config.asyncStorage, ASYNC_STORAGE_PERSISTENT_SUPER_PROPERTIES_KEY)];
                    case 1:
                        _b.persistentSuperProperties = _d.sent();
                        _c = this;
                        return [4 /*yield*/, this.config.asyncStorage.getItem(ASYNC_STORAGE_USER_IDENTIFICATION_KEY)];
                    case 2:
                        _c.userIdentification = _d.sent();
                        setInterval(function () { return _this.uploadEntries(); }, UPLOAD_INTERVAL);
                        return [2 /*return*/, this.uploadEntries()];
                }
            });
        });
    };
    /**
     * Identifies the current user with a unique string, such as a user id, an email address, a phone number or whatever you use to uniquely identify your users. User identification gets persisted between launches but it doesn't hurt to re-identify.
     *
     * @param {string} userIdentification A string that uniquely identifies your user.
     * @memberof Nibbana
     */
    Nibbana.prototype.identify = function (userIdentification) {
        return __awaiter(this, void 0, void 0, function () {
            var config, usersFirstIdentifiedAt;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        config = this.ensureConfig();
                        if (!userIdentification) {
                            throw new Error('userIdentification must not be falsy');
                        }
                        return [4 /*yield*/, config.asyncStorage.setItem(ASYNC_STORAGE_USER_IDENTIFICATION_KEY, userIdentification)];
                    case 1:
                        _a.sent();
                        return [4 /*yield*/, react_native_async_storage_utils_1.getObject(config.asyncStorage, ASYNC_STORAGE_USERS_FIRST_IDENTIFIED_AT)];
                    case 2:
                        usersFirstIdentifiedAt = _a.sent();
                        if (!!usersFirstIdentifiedAt[userIdentification]) return [3 /*break*/, 4];
                        usersFirstIdentifiedAt[userIdentification] = new Date();
                        return [4 /*yield*/, react_native_async_storage_utils_1.setValue(config.asyncStorage, ASYNC_STORAGE_USERS_FIRST_IDENTIFIED_AT, usersFirstIdentifiedAt)];
                    case 3:
                        _a.sent();
                        _a.label = 4;
                    case 4: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Sets super properties that get saved with every log entry. This function merges whatever you give you into your existing super properties. They are useful for stuff like additional information you have about your users or your environment.
     *
     * @param {object} superProperties An object to be merged into your existing super properties.
     * @param {boolean} [persistent=false] Whether the super properties you are calling the function with should be persisted between app launches.
     * @memberof Nibbana
     */
    Nibbana.prototype.extendSuperProperties = function (superProperties, persistent) {
        if (persistent === void 0) { persistent = false; }
        return __awaiter(this, void 0, void 0, function () {
            var config, _i, _a, key, _b, _c, key;
            return __generator(this, function (_d) {
                switch (_d.label) {
                    case 0:
                        config = this.ensureConfig();
                        if (persistent) {
                            lodash_1.merge(this.persistentSuperProperties, superProperties);
                            for (_i = 0, _a = Object.keys(superProperties); _i < _a.length; _i++) {
                                key = _a[_i];
                                delete this.transientSuperProperties[key];
                            }
                        }
                        else {
                            lodash_1.merge(this.transientSuperProperties, superProperties);
                            for (_b = 0, _c = Object.keys(superProperties); _b < _c.length; _b++) {
                                key = _c[_b];
                                delete this.persistentSuperProperties[key];
                            }
                        }
                        return [4 /*yield*/, react_native_async_storage_utils_1.setValue(config.asyncStorage, ASYNC_STORAGE_PERSISTENT_SUPER_PROPERTIES_KEY, this.persistentSuperProperties)];
                    case 1:
                        _d.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Unsets a single super property.
     *
     * @param {string} superPropertyName The name of the property you want to delete.
     * @memberof Nibbana
     */
    Nibbana.prototype.unsetSuperProperty = function (superPropertyName) {
        return __awaiter(this, void 0, void 0, function () {
            var config;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        config = this.ensureConfig();
                        delete this.transientSuperProperties[superPropertyName];
                        delete this.persistentSuperProperties[superPropertyName];
                        return [4 /*yield*/, react_native_async_storage_utils_1.setValue(config.asyncStorage, ASYNC_STORAGE_PERSISTENT_SUPER_PROPERTIES_KEY, this.persistentSuperProperties)];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Resets your super properties (transient and persistent) to the empty object.
     *
     * @memberof Nibbana
     */
    Nibbana.prototype.clearSuperProperties = function () {
        return __awaiter(this, void 0, void 0, function () {
            var config;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        config = this.ensureConfig();
                        this.transientSuperProperties = {};
                        this.persistentSuperProperties = {};
                        return [4 /*yield*/, react_native_async_storage_utils_1.setValue(config.asyncStorage, ASYNC_STORAGE_PERSISTENT_SUPER_PROPERTIES_KEY, this.persistentSuperProperties)];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    // TODO(jan): Only set this when uploading the entries
    Nibbana.prototype.getContext = function () {
        var _a = require('react-native'), NativeModules = _a.NativeModules, Platform = _a.Platform;
        var locale = null;
        if (Platform.OS === 'ios') {
            locale = lodash_1.get(NativeModules, 'SettingsManager.settings.AppleLocale', null);
        }
        else if (Platform.OS === 'android') {
            locale = lodash_1.get(NativeModules, 'I18nManager.localeIdentifier', null);
        }
        var context = {
            nibbanaVersion: NIBBANA_VERSION,
            locale: locale,
        };
        try {
            var DeviceInfo = require('react-native-device-info');
            context = __assign({}, context, { isEmulator: DeviceInfo.isEmulator(), brand: DeviceInfo.getBrand(), bundleId: DeviceInfo.getBundleId(), deviceId: DeviceInfo.getDeviceId(), manufacturer: DeviceInfo.getManufacturer(), model: DeviceInfo.getModel(), systemName: DeviceInfo.getSystemName(), isTablet: DeviceInfo.isTablet(), deviceCountry: DeviceInfo.getDeviceCountry(), deviceLocale: DeviceInfo.getDeviceLocale(), systemVersion: DeviceInfo.getSystemVersion(), timezone: DeviceInfo.getTimezone(), userAgent: DeviceInfo.getUserAgent(), nativeAppVersion: DeviceInfo.getVersion(), buildNumber: DeviceInfo.getBuildNumber(), jsAppVersion: APP_VERSION });
        }
        catch (e) { }
        return context;
    };
    /**
     * This starts a timer for the event with the given name. The next time you call trackEvent for the event, the time between you called startTimerForEvent and the time you called trackEvent will get saved on the event as duration.
     *
     * @param {string} eventName The event name
     * @memberof Nibbana
     */
    Nibbana.prototype.startTimerForEvent = function (eventName) {
        this.startTimerCalledAtDates[eventName] = new Date();
    };
    /**
     * Clears timers you set with {@link Nibbana#startTimerForEvent}.
     *
     * @param {string} eventName The event name
     * @memberof Nibbana
     */
    Nibbana.prototype.clearTimerForEvent = function (eventName) {
        delete this.startTimerCalledAtDates[eventName];
    };
    /**
     * Logs an event. This function takes an optional payload parameter that can contain any additional data you want to save with the event. Even though this function is asynchronous, you shouldn't await on it.
     *
     * @param {string} name The event name. Use something readable like "Awesome button pressed"
     * @param {object} [payload={}] Additional data you want to save with the event. This should be JSON serializable.
     * @memberof Nibbana
     */
    Nibbana.prototype.logEvent = function (name, payload) {
        if (payload === void 0) { payload = {}; }
        return __awaiter(this, void 0, void 0, function () {
            var config, event;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        config = this.ensureConfig();
                        event = {
                            _id: fresh_id_1.default(),
                            occurredAt: new Date(),
                            type: 'EVENT',
                            name: name,
                            payload: __assign({}, payload),
                            userIdentification: this.userIdentification,
                            superProperties: __assign({}, this.persistentSuperProperties, this.transientSuperProperties),
                        };
                        if (this.startTimerCalledAtDates[name]) {
                            event.duration = +new Date() - +this.startTimerCalledAtDates[name];
                            this.clearTimerForEvent(name);
                        }
                        return [4 /*yield*/, this.entriesLock.acquire()];
                    case 1:
                        _a.sent();
                        _a.label = 2;
                    case 2:
                        _a.trys.push([2, , 4, 5]);
                        return [4 /*yield*/, react_native_async_storage_utils_1.enqueue(config.asyncStorage, ASYNC_STORAGE_ENTRIES_KEY, event)];
                    case 3:
                        _a.sent();
                        return [3 /*break*/, 5];
                    case 4:
                        this.entriesLock.release();
                        return [7 /*endfinally*/];
                    case 5:
                        this.uploadEntries();
                        return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Logs an error. This function takes an optional payload parameter that can contain any additional data you want to save with the event. Even though this function is asynchronous, you shouldn't await on it.
     *
     * @param {Error} error
     * @param {object} [payload={}] Additional data you want to save with the event. This should be JSON serializable.
     * @memberof Nibbana
     */
    Nibbana.prototype.logError = function (error, payload) {
        if (payload === void 0) { payload = {}; }
        return __awaiter(this, void 0, void 0, function () {
            var config, errorEntry;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        config = this.ensureConfig();
                        errorEntry = {
                            _id: fresh_id_1.default(),
                            occurredAt: new Date(),
                            type: 'ERROR',
                            message: error.message,
                            name: error.name,
                            stack: error.stack || null,
                            payload: __assign({}, payload),
                            userIdentification: this.userIdentification,
                            superProperties: __assign({}, this.persistentSuperProperties, this.transientSuperProperties),
                        };
                        return [4 /*yield*/, this.entriesLock.acquire()];
                    case 1:
                        _a.sent();
                        _a.label = 2;
                    case 2:
                        _a.trys.push([2, , 4, 5]);
                        return [4 /*yield*/, react_native_async_storage_utils_1.enqueue(config.asyncStorage, ASYNC_STORAGE_ENTRIES_KEY, errorEntry)];
                    case 3:
                        _a.sent();
                        return [3 /*break*/, 5];
                    case 4:
                        this.entriesLock.release();
                        return [7 /*endfinally*/];
                    case 5:
                        this.uploadEntries();
                        return [2 /*return*/];
                }
            });
        });
    };
    Nibbana.prototype.uploadEntries = function () {
        return __awaiter(this, void 0, void 0, function () {
            var entriesToBeUploaded, context_1, entriesWithContext, idsOfUploadedEntries_1, e_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!this.config) {
                            return [2 /*return*/];
                        }
                        return [4 /*yield*/, this.uploadLock.acquire()];
                    case 1:
                        _a.sent();
                        _a.label = 2;
                    case 2:
                        _a.trys.push([2, 10, 11, 12]);
                        return [4 /*yield*/, react_native_async_storage_utils_1.getArray(this.config.asyncStorage, ASYNC_STORAGE_ENTRIES_KEY)];
                    case 3:
                        entriesToBeUploaded = _a.sent();
                        if (entriesToBeUploaded.length === 0) {
                            return [2 /*return*/];
                        }
                        context_1 = this.getContext();
                        entriesWithContext = entriesToBeUploaded.map(function (e) { return (__assign({}, e, { context: context_1 })); });
                        return [4 /*yield*/, this.config.uploadEntries(entriesWithContext)];
                    case 4:
                        _a.sent();
                        idsOfUploadedEntries_1 = entriesWithContext.map(function (e) { return e._id; });
                        return [4 /*yield*/, this.entriesLock.acquire()];
                    case 5:
                        _a.sent();
                        _a.label = 6;
                    case 6:
                        _a.trys.push([6, , 8, 9]);
                        return [4 /*yield*/, react_native_async_storage_utils_1.filterArray(this.config.asyncStorage, ASYNC_STORAGE_ENTRIES_KEY, function (e) { return !idsOfUploadedEntries_1.includes(e._id); })];
                    case 7:
                        _a.sent();
                        return [3 /*break*/, 9];
                    case 8:
                        this.entriesLock.release();
                        return [7 /*endfinally*/];
                    case 9: return [3 /*break*/, 12];
                    case 10:
                        e_1 = _a.sent();
                        if (__DEV__) {
                            console.log("[nibbana] Error uploading entries: " + e_1.message);
                        }
                        return [3 /*break*/, 12];
                    case 11:
                        this.uploadLock.release();
                        return [7 /*endfinally*/];
                    case 12: return [2 /*return*/];
                }
            });
        });
    };
    Nibbana._shared = null;
    return Nibbana;
}());
exports.default = Nibbana;
